//+------------------------------------------------------------------+
//|                       Open Close Controll SOK-Daniel DAVID       |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.ewtrader.wz.cz  |
//+------------------------------------------------------------------+
extern string Pair1="EURUSD";     // Nzvy instrument 
extern string Pair2="GBPUSD"; 
extern string Pair3="EURGBP";              
extern int SLIP=1;                 // Slippage
extern int FirstMG=1;              // Prvn Magic Number
extern int MaxMG=5;                // Maximalni pocet pozic = MagicNumbers
extern color TableHeadClr=White;   // Barva hlaviky tabulky
extern double MinVol=0.01;         // Minimln ojbem lot co povoluje Brooker
//+------------------------------------------------------------------+
//|             Start                                                |
//+------------------------------------------------------------------+
int start()
 {
   string i1,i2,i3,i4,i5 ;
   double pt,prof, pr , p1vol , p2vol , p3vol,ob;
   int cnt,mg,mgf, ticket, total,poz , inp,radek;
   color clr;
   
   
    ObjectDelete("i");  // Zhlav taulky MG, profitu a PT
    ObjectCreate("i", OBJ_LABEL, 0, 0, 0);
    ObjectSetText("i"," MG      Profit      Close       PT ", 8, "Arial", TableHeadClr);
    ObjectSet("i", OBJPROP_CORNER, 1);
    ObjectSet("i", OBJPROP_XDISTANCE, 5);
    ObjectSet("i", OBJPROP_YDISTANCE, 265);
    
    if ( ObjectFind("B1") != 0 && ObjectFind("S1") != 0) //Poten nastaven B=Buy  a S =Sell  vlevo od kombinac
       {
        ObjectDelete("B1");
        ObjectCreate("B1", OBJ_LABEL, 0, 0, 0);
        ObjectSetText("B1","B", 10, "Arial", Green);
        ObjectSet("B1", OBJPROP_CORNER, 1);
        ObjectSet("B1", OBJPROP_XDISTANCE,110);
        ObjectSet("B1", OBJPROP_YDISTANCE, 114);
      
        ObjectDelete("S1");
        ObjectCreate("S1", OBJ_LABEL, 0, 0, 0);
        ObjectSetText("S1","S", 10, "Arial", Orange);
        ObjectSet("S1", OBJPROP_CORNER, 1);
        ObjectSet("S1", OBJPROP_XDISTANCE, 110);
        ObjectSet("S1", OBJPROP_YDISTANCE, 132);
       }  
    if ( ObjectFind("B2") != 0 && ObjectFind("S2") != 0)
       {
        ObjectDelete("B2");
        ObjectCreate("B2", OBJ_LABEL, 0, 0, 0);
        ObjectSetText("B2","B", 10, "Arial", Green);
        ObjectSet("B2", OBJPROP_CORNER, 1);
        ObjectSet("B2", OBJPROP_XDISTANCE,110);
        ObjectSet("B2", OBJPROP_YDISTANCE, 157);
    
        ObjectDelete("S2");
        ObjectCreate("S2", OBJ_LABEL, 0, 0, 0);
        ObjectSetText("S2","S", 10, "Arial", Orange);
        ObjectSet("S2", OBJPROP_CORNER, 1);
        ObjectSet("S2", OBJPROP_XDISTANCE, 110);
        ObjectSet("S2", OBJPROP_YDISTANCE, 175);
       }  
    if ( ObjectFind("B3") != 0 && ObjectFind("S3") != 0)
       {
        ObjectDelete("B3");
        ObjectCreate("B3", OBJ_LABEL, 0, 0, 0);
        ObjectSetText("B3","B", 10, "Arial", Green);
        ObjectSet("B3", OBJPROP_CORNER, 1);
        ObjectSet("B3", OBJPROP_XDISTANCE,110);
        ObjectSet("B3", OBJPROP_YDISTANCE, 200);
      
        ObjectDelete("S3");
        ObjectCreate("S3", OBJ_LABEL, 0, 0, 0);
        ObjectSetText("S3","S", 10, "Arial", Orange);
        ObjectSet("S3", OBJPROP_CORNER, 1);
        ObjectSet("S3", OBJPROP_XDISTANCE, 110);
        ObjectSet("S3", OBJPROP_YDISTANCE, 218);
       }  
       
       
    total=OrdersTotal();radek=0;
    for (mg=FirstMG;mg<FirstMG+MaxMG;mg++)// kontrola open pozic podle Magic numbers a vypsn tabulky
     { prof=0; poz=0;radek++;
      for(cnt=0;cnt<total;cnt++)
       {
       OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);        //zjisti zda je uz na 
       if(OrderSymbol()==Pair1 && OrderMagicNumber()==mg)   //instrumentu otevrena nejaka pozice
        {prof=prof+OrderProfit();poz=poz+1;  // Kontrola otevench pozic a peten
        }
       if(OrderSymbol()==Pair2 && OrderMagicNumber()==mg)  
        {prof=prof+OrderProfit();poz=poz+1;
        } 
       if(OrderSymbol()==Pair3 && OrderMagicNumber()==mg)  
        {prof=prof+OrderProfit();poz=poz+1;
        }       
      }
        if (prof==0) clr=Yellow;
        if (prof>0) clr=Lime;
        if (prof<0) clr= Red;
        i1= DoubleToStr(mg,0);
        i2=i1+"p"; // Profit
        i3=i1+"c"; // Close kek
        i4=i1+"pt";// Profit Take
        
      if ( ObjectFind(i3) != 0 && poz==3)  
         {PoziceClose(mg);ObjectDelete(i4);PlaySound("alert.wav"); }// Close pozice pokud smau kek = Manual Close
      if (poz==3) {ObjectSet(i3,6,clr);}  // barva Close kku podle barvy profitu
      if (poz<3) ObjectSet(i3,6,Yellow);// Barva close kku kdy nen na tomto MG oteven pozice= lut
      
      ObjectDelete(i1);                  // Tabulka pozic
      ObjectCreate(i1, OBJ_LABEL, 0, 0, 0);
      ObjectSetText(i1,mg+" ", 9, "Arial", Aqua);  // Magic number
      if (poz==3) ObjectSet(i1,6,clr);
      ObjectSet(i1, OBJPROP_CORNER, 1);
      ObjectSet(i1, OBJPROP_XDISTANCE, 135);
      ObjectSet(i1, OBJPROP_YDISTANCE, 265+(radek*11));
      ObjectDelete(i2);
      ObjectCreate(i2, OBJ_LABEL, 0, 0, 0);        //Profit pozice
      ObjectSetText(i2,DoubleToStr(prof,1), 9, "Arial", clr);
      ObjectSet(i2, OBJPROP_CORNER, 1);
      ObjectSet(i2, OBJPROP_XDISTANCE, 90);
      ObjectSet(i2, OBJPROP_YDISTANCE, 265+(radek*11));
       if ( ObjectFind(i3) != 0)                  // Close kek
       {
        ObjectDelete(i3);
        ObjectCreate(i3, OBJ_LABEL, 0, 0, 0);
        ObjectSetText(i3,"X", 9, "Arial", Yellow);
        ObjectSet(i3, OBJPROP_CORNER, 1);
        ObjectSet(i3, OBJPROP_XDISTANCE, 53);
        ObjectSet(i3, OBJPROP_YDISTANCE, 265+(radek*11));
       }
        if ( ObjectFind(i4) != 0)                   // Profit take
       {
        ObjectDelete(i4);
        ObjectCreate(i4, OBJ_LABEL, 0, 0, 0);
        ObjectSetText(i4,"0", 9, "Arial", Lime);
        ObjectSet(i4, OBJPROP_CORNER, 1);
        ObjectSet(i4, OBJPROP_XDISTANCE, 10);
        ObjectSet(i4, OBJPROP_YDISTANCE, 265+(radek*11));
       } 
       pr=StrToDouble(ObjectDescription(i4));  // pete PT z tabulky
       
       if (prof>=pr && pr>0) 
          {PoziceClose(mg);ObjectDelete(i4);PlaySound("alert.wav");} // Close pozice pi dosaen PT
     } 
      
      
   //------------------------Vstupy---------------------------------------------------------------------------------  
    if ( ObjectFind("B1") != 0 && ObjectFind("S1") == 0 && ObjectFind("S2") == 0 && ObjectFind("B2") == 0
        && ObjectFind("S3") == 0 && ObjectFind("B3") == 0) 
      {  mgf=0;ob=0;
         for (mg=FirstMG;mg<FirstMG+MaxMG;mg++)
          { i5= DoubleToStr(mg,0);
            if(ObjectGet(i5,6)==Aqua){mgf=mg;mg=FirstMG+MaxMG;}
          }
         if (mgf==0)
            {PlaySound("alert.wav");
             int ru1=MessageBox( "Rozite poet MagicNumbers MaxMG","Nen voln pozice", 0x00000000); 
             ObjectDelete("S1");
            }        
         if (mgf>0)
         { 
          p1vol=StrToDouble(ObjectDescription("p11")); // peten hodnot lot
          p2vol=StrToDouble(ObjectDescription("p21")); 
          p3vol=StrToDouble(ObjectDescription("p31"));
          if (p1vol<MinVol || p2vol<MinVol || p3vol<MinVol ) 
             {PlaySound("alert.wav");int ru14=MessageBox( "Zvednout Objem v Lotech","Mal objem", 0x00000000);ob=1;ObjectDelete("S1");}
          if (ob==0)                                    // Kontrola min objemu v lotech- ochrana pred zacyklenim Open funkce
           {   
           PoziceOpenDetail(Pair1, p1vol, 1, mgf);       // Oteven pozice BUY 
           PoziceOpenDetail(Pair2, p2vol, 1, mgf); 
           PoziceOpenDetail(Pair3, p3vol, -1, mgf);
           PlaySound("expert.wav");ObjectDelete("S1");
           }
         }
       }  
     if ( ObjectFind("B1") == 0 && ObjectFind("S1") != 0 && ObjectFind("S2") == 0 && ObjectFind("B2") == 0
        && ObjectFind("S3") == 0 && ObjectFind("B3") == 0) 
       { mgf=0;ob=0;
         for (mg=FirstMG;mg<FirstMG+MaxMG;mg++)
          { i5= DoubleToStr(mg,0);
            if(ObjectGet(i5,6)==Aqua){mgf=mg;mg=FirstMG+MaxMG+1;}
          }
         if (mgf==0)
            {PlaySound("alert.wav");
             int ru2=MessageBox( "Rozite poet MagicNumbers MaxMG","Nen voln pozice", 0x00000000); 
             ObjectDelete("B1");
            }   
         if (mgf>0)
         { 
          p1vol=StrToDouble(ObjectDescription("p11")); 
          p2vol=StrToDouble(ObjectDescription("p21")); 
          p3vol=StrToDouble(ObjectDescription("p31")); 
          if (p1vol<MinVol || p2vol<MinVol || p3vol<MinVol ) 
             {PlaySound("alert.wav");int ru15=MessageBox( "Zvednout Objem v Lotech","Mal objem", 0x00000000);ob=1;ObjectDelete("B1");}
          if (ob==0)
          {
           PoziceOpenDetail(Pair1, p1vol, -1, mgf);   // Oteven pozice SELL
           PoziceOpenDetail(Pair2, p2vol, -1, mgf); 
           PoziceOpenDetail(Pair3, p3vol, 1, mgf);
           PlaySound("expert.wav");ObjectDelete("B1");
          }
         }   
        } 
    //---------------------     
   if ( ObjectFind("B1") == 0 && ObjectFind("S1") == 0 && ObjectFind("S2") == 0 && ObjectFind("B2") != 0
        && ObjectFind("S3") == 0 && ObjectFind("B3") == 0) 
      {  mgf=0;ob=0;
         for (mg=FirstMG;mg<FirstMG+MaxMG;mg++)
          { i5= DoubleToStr(mg,0);
            if(ObjectGet(i5,6)==Aqua){mgf=mg;mg=FirstMG+MaxMG+1;}
          }
         if (mgf==0)
            {PlaySound("alert.wav");
             int ru3=MessageBox( "Rozite poet MagicNumbers MaxMG","Nen voln pozice", 0x00000000); 
             ObjectDelete("S2");
            }        
         if (mgf>0)
         { 
          p1vol=StrToDouble(ObjectDescription("p41")); // peten hodnot lot
          p2vol=StrToDouble(ObjectDescription("p51")); 
          p3vol=StrToDouble(ObjectDescription("p61")); 
          if (p1vol<MinVol || p2vol<MinVol || p3vol<MinVol ) 
             {PlaySound("alert.wav");int ru16=MessageBox( "Zvednout Objem v Lotech","Mal objem", 0x00000000);ob=1;ObjectDelete("S2");}
          if (ob==0)
          {
           PoziceOpenDetail(Pair1, p1vol, 1, mgf);       // Oteven pozice BUY 
           PoziceOpenDetail(Pair3, p2vol, 1, mgf); 
           PoziceOpenDetail(Pair2, p3vol, -1, mgf);
           PlaySound("expert.wav");ObjectDelete("S2");
          } 
         }
       }  
     if ( ObjectFind("B1") == 0 && ObjectFind("S1") == 0 && ObjectFind("S2") != 0 && ObjectFind("B2") == 0
        && ObjectFind("S3") == 0 && ObjectFind("B3") == 0) 
       { mgf=0;ob=0;
         for (mg=FirstMG;mg<FirstMG+MaxMG;mg++)
          { i5= DoubleToStr(mg,0);
            if(ObjectGet(i5,6)==Aqua){mgf=mg;mg=FirstMG+MaxMG+1;}
          }
         if (mgf==0)
            {PlaySound("alert.wav");
             int ru4=MessageBox( "Rozite poet MagicNumbers MaxMG","Nen voln pozice", 0x00000000); 
             ObjectDelete("B2");
            }   
         if (mgf>0)
         { 
          p1vol=StrToDouble(ObjectDescription("p41")); 
          p2vol=StrToDouble(ObjectDescription("p51")); 
          p3vol=StrToDouble(ObjectDescription("p61")); 
          if (p1vol<MinVol || p2vol<MinVol || p3vol<MinVol ) 
             {PlaySound("alert.wav");int ru17=MessageBox( "Zvednout Objem v Lotech","Mal objem", 0x00000000);ob=1;ObjectDelete("B2");}
          if (ob==0)                                    // Kontrola min objemu v lotech- ochrana pred zacyklenim Open funkce
           { 
            PoziceOpenDetail(Pair1, p1vol, -1, mgf);   // Oteven pozice SELL
            PoziceOpenDetail(Pair3, p2vol, -1, mgf); 
            PoziceOpenDetail(Pair2, p3vol, 1, mgf);
            PlaySound("expert.wav");ObjectDelete("B2");
           } 
         }   
        }        
 //---------------------------------        
   if ( ObjectFind("B1") == 0 && ObjectFind("S1") == 0 && ObjectFind("S2") == 0 && ObjectFind("B2") == 0
        && ObjectFind("S3") == 0 && ObjectFind("B3") != 0) 
      {  mgf=0;ob=0;
         for (mg=FirstMG;mg<FirstMG+MaxMG;mg++)
          { i5= DoubleToStr(mg,0);
            if(ObjectGet(i5,6)==Aqua){mgf=mg;mg=FirstMG+MaxMG+1;}
          }
         if (mgf==0)
            {PlaySound("alert.wav");
             int ru5=MessageBox( "Rozite poet MagicNumbers MaxMG","Nen voln pozice", 0x00000000); 
             ObjectDelete("S3");
            }        
         if (mgf>0)
         { 
          p1vol=StrToDouble(ObjectDescription("p71")); // peten hodnot lot
          p2vol=StrToDouble(ObjectDescription("p81")); 
          p3vol=StrToDouble(ObjectDescription("p91")); 
          if (p1vol<MinVol || p2vol<MinVol || p3vol<MinVol ) 
             {PlaySound("alert.wav");int ru18=MessageBox( "Zvednout Objem v Lotech","Mal objem", 0x00000000);ob=1;ObjectDelete("S3");}
          if (ob==0)                                    // Kontrola min objemu v lotech- ochrana pred zacyklenim Open funkce
           { 
            PoziceOpenDetail(Pair2, p1vol, 1, mgf);       // Oteven pozice BUY 
            PoziceOpenDetail(Pair3, p2vol, 1, mgf); 
            PoziceOpenDetail(Pair1, p3vol, -1, mgf);
            PlaySound("expert.wav");ObjectDelete("S3");
           } 
         }
       }  
     if ( ObjectFind("B1") == 0 && ObjectFind("S1") == 0 && ObjectFind("S2") == 0 && ObjectFind("B2") == 0
        && ObjectFind("S3") != 0 && ObjectFind("B3") == 0) 
       { mgf=0;ob=0;
         for (mg=FirstMG;mg<FirstMG+MaxMG;mg++)
          { i5= DoubleToStr(mg,0);
            if(ObjectGet(i5,6)==Aqua){mgf=mg;mg=FirstMG+MaxMG+1;}
          }
         if (mgf==0)
            {PlaySound("alert.wav");
             int ru6=MessageBox( "Rozite poet MagicNumbers MaxMG","Nen voln pozice", 0x00000000); 
             ObjectDelete("B3");
            }   
         if (mgf>0)
         { 
          p1vol=StrToDouble(ObjectDescription("p71")); 
          p2vol=StrToDouble(ObjectDescription("p81")); 
          p3vol=StrToDouble(ObjectDescription("p91")); 
          if (p1vol<MinVol || p2vol<MinVol || p3vol<MinVol ) 
            {PlaySound("alert.wav");int ru19=MessageBox( "Zvednout Objem v Lotech","Mal objem", 0x00000000);ob=1;ObjectDelete("B3");}
          if (ob==0)                                    // Kontrola min objemu v lotech- ochrana pred zacyklenim Open funkce
           { 
            PoziceOpenDetail(Pair2, p1vol, -1, mgf);   // Oteven pozice SELL
            PoziceOpenDetail(Pair3, p2vol, -1, mgf); 
            PoziceOpenDetail(Pair1, p3vol, 1, mgf);
            PlaySound("expert.wav");ObjectDelete("B3");
           } 
         }   
        }                
     
     
   return(0);
  }
  //----oteven pru a kontrola dokud nen oteven--------------------
  void PoziceOpenDetail(string Symb, double Lot, int Smer, int Magic) {
   int Ticket = -1;
   string mgs;
   
   mgs=DoubleToStr(Magic,0); 
   //   cyklus dokud neni OK
   while (Ticket<=0) {
      RefreshRates();
      switch (Smer) {
         case  1  :
            Ticket = OrderSend(Symb, OP_BUY, Lot, MarketInfo(Symb, MODE_ASK), SLIP, 0, 0, mgs, Magic);
            break;
         case -1  :
            Ticket = OrderSend(Symb, OP_SELL, Lot, MarketInfo(Symb, MODE_BID), SLIP, 0, 0, mgs, Magic);
            break;
      }   //   switch
   }   //   while
}
// -------------Close vech pozic najednou---------------------------
void PoziceClose(int Magic) {
   int err;
   bool ok;
   
   for (int i=OrdersTotal()-1; i>=0; i--) {
      if (OrderSelect(i, SELECT_BY_POS) && OrderMagicNumber()==Magic) {
         ok=false;
         while(!ok) {
            RefreshRates();
            switch(OrderType()) {
               case OP_BUY  :
                  ok = OrderClose(OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), SLIP);
                  break;
               case OP_SELL :
                  ok = OrderClose(OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), SLIP);
                  break;
            }   //   switch
         }   //   while
      }   //   if
   }   //   for
}

// the end.